/*
 * Copyright (c) 2013, Texas Instruments Incorporated
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * *  Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 * *  Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * *  Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
 * THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
 * PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
 * OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
 * EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
/*
 *  ======== SemMP_posix.c ========
 */

/* This define must precede inclusion of any xdc header files */
#define Registry_CURDESC ti_sdo_ce_osal_SemMP_desc

#include <xdc/std.h>
#include <xdc/runtime/Assert.h>
#include <xdc/runtime/Diags.h>
#include <xdc/runtime/Log.h>
#include <xdc/runtime/Registry.h>

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

#include <ti/sdo/ce/osal/Memory.h>
#include <ti/sdo/ce/osal/Global.h>

#include <ti/sdo/ce/osal/SemMP.h>

/*
 *  Linux IPC semaphores are identified by a 32 bit key, and the same semaphore
 *  can be obtained accross processes by calling semget() with the same key.
 *  These semaphores actually consist of an array of semaphores. We use a
 *  semaphore with an array of 2 semaphores to implement the SemMP_Obj. The
 *  first semaphore in the array will hold the semaphore count, and the second
 *  will hold a reference count of the number of times that the semaphore
 *  has been "created" (ie the number of times semget() has been called for
 *  the given key).
 */
#define _SemMP_SEMCOUNT 0 /* Array index of semaphore holding the count */
#define _SemMP_REFCOUNT 1 /* Array index of semaphore holding the ref count */

#define NUMSEMS 2 /* Size of semaphore array */

/*
 *  ID of semaphore for handling critical sections in this module. This is
 *  auto-generated by Global.xdt.
 */
extern UInt32 ti_sdo_ce_osal_linux_SemMP_ipcKey;

/* Maximum tries to enter critical section before printing warning */
#define MAXCOUNT 100000



/*
 *  ======== SemMP_Obj ========
 */
typedef struct SemMP_Obj {
    Int id;     /* ID of IPC semaphore */
} SemMP_Obj;

/*
 *  ======== SemUnion ========
 *  Linux semctl() calls take as one of the arguments, a parameter of the
 *  following type:
 *
 *  union semun {
 *     int              val;    * Value for SETVAL *
 *     struct semid_ds *buf;    * Buffer for IPC_STAT, IPC_SET *
 *     unsigned short  *array;  * Array for GETALL, SETALL *
 *     struct seminfo  *__buf;  * Buffer for IPC_INFO (Linux specific) *
 * };
 *
 *  In some earlier versions of glibc, the semun union was defined in
 *  <sys/sem.h>, but POSIX.1-2001 requires that the caller define this union.
 *  On versions of glibc where this union is not defined, the macro
 *  _SEM_SEMUN_UNDEFINED is defined in <sys/sem.h>.
 */
typedef union SemUnion {
    Int val;
    struct semid_ds *buf;
    unsigned short *array;
    struct seminfo  *__buf;
} SemUnion;

/*
 *  REMINDER: If you add an initialized static variable, reinitialize it at
 *  cleanup
 */

Registry_Desc ti_sdo_ce_osal_SemMP_desc;

static Int regInit = 0;     /* Registry_addModule() called */
static Int curInit = 0;

static Void    cleanup(Void);

static Int enterCS(Int key);
static Void exitCS(Int id);

/*
 *  ======== SemMP_create ========
 */
SemMP_Handle SemMP_create(Int key, Int count)
{
    Int     mutexId;
    Int     semId;
    SemMP_Obj *sem;
    SemUnion semU;
    struct sembuf semBuf;

    Log_print2(Diags_ENTRY, "[+E] SemMP_create> key: 0x%x count: %d",
            (IArg)key, (IArg)count);

    if ((sem = (SemMP_Obj *)Memory_alloc(sizeof(SemMP_Obj), NULL)) == NULL) {
        Log_print0(Diags_USER7, "[+7] SemMP_create> Memory_alloc failed");
        return (NULL);
    }

    /* Enter critical section */
    mutexId = enterCS(ti_sdo_ce_osal_linux_SemMP_ipcKey);

    /*
     *  First try to create semaphore with exclusive access, so we know
     *  whether or not it has already been created.
     */
    semId = semget((key_t)key, NUMSEMS, 0666 | IPC_CREAT | IPC_EXCL);

    if (semId == -1) {
        /* Semaphore may have already been created */
        semId = semget((key_t)key, NUMSEMS, 0666 | IPC_CREAT);
        if (semId == -1) {
            /* Error */

            /* Leave critical section */
            exitCS(mutexId);

            Log_print1(Diags_USER7, "[+7] SemMP_create> semget 0x%x failed",
                    (IArg)key);
            Memory_free(sem, sizeof(SemMP_Obj), NULL);
            return (NULL);
        }

        /* Successfully attached to existing semaphore */
    }
    else {
        /*
         *  This is the first time this semaphore has been created, so
         *  we need to initialize its value.
         */
        semU.val = count;
        if (semctl(semId, _SemMP_SEMCOUNT, SETVAL, semU) == -1) {
            Log_print1(Diags_USER7,
                    "[+7] SemMP_create> Failed to init count of 0x%x",
                    (IArg)semId);

            /*
             *  Failed to set value, try to delete semaphore. Note: the second
             *  argument (semaphore number) will be ignored in this call.
             */
            if (semctl(semId, 0, IPC_RMID, semU) == -1) {
                Log_print1(Diags_USER7,
                        "[+7] SemMP_create> semctl(0x%x, 0, IPC_RMID,...) fa"
                        "iled", (IArg)semId);
            }

            /* Leave critical section */
            exitCS(mutexId);

            Memory_free(sem, sizeof(SemMP_Obj), NULL);
            return (NULL);
        }

        /* Use the second semaphore as a reference count, initialize to 0 */
        semU.val = 0;
        if (semctl(semId, _SemMP_REFCOUNT, SETVAL, semU) == -1) {
            Log_print1(Diags_USER7,
                    "[+7] SemMP_create> Failed to init ref count of 0x%x",
                    (IArg)semId);

            /*
             *  Failed to set value, try to delete semaphore. Note: the second
             *  argument (semaphore number) will be ignored in this call.
             */
            if (semctl(semId, 0, IPC_RMID, semU) == -1) {
                Log_print1(Diags_USER7,
                        "[+7] SemMP_create> semctl(0x%x, 0, IPC_RMID,...) fa"
                        "iled", (IArg)semId);
            }

            /* Leave critical section */
            exitCS(mutexId);

            Memory_free(sem, sizeof(SemMP_Obj), NULL);
            return (NULL);
        }
    }

    sem->id = semId;

    /* Increment reference count */
    semBuf.sem_num = _SemMP_REFCOUNT;
    semBuf.sem_op = 1;
    semBuf.sem_flg = SEM_UNDO;

    if (semop(semId, &semBuf, 1) == -1) {
        Log_print1(Diags_USER7,
                "[+7] SemMP_create> Failed to increment ref count on 0x%x",
                (IArg)semId);
        Assert_isTrue(0 == 1, (Assert_Id)NULL);
    }

    Log_print2(Diags_ENTRY, "[+E] SemMP_create> semId: 0x%x refCount: %d",
            Log_print2(Diags_ENTRY,
            "[+E] SemMP_create> semId: 0x%x refCount: %d", semId, semctl(semId,
            _SemMP_REFCOUNT, (IArg)GETVAL, (IArg)(semU)));

    /* Leave critical section */
    exitCS(mutexId);

    Log_print1(Diags_EXIT, "[+X] Leaving SemMP_create> sem[0x%x]", (IArg)sem);

    return (sem);
}

/*
 *  ======== SemMP_delete ========
 */
Void SemMP_delete(SemMP_Handle sem)
{
    Int     mutexId;
    Int     refCount;
    SemUnion semU;
    struct sembuf semBuf;

    Log_print1(Diags_ENTRY, "[+E] Entered SemMP_delete> sem[0x%x]", (IArg)sem);

    if (sem != NULL) {
        /* Enter critical section */
        mutexId = enterCS(ti_sdo_ce_osal_linux_SemMP_ipcKey);

        Log_print2(Diags_ENTRY, "[+E] SemMP_delete> sem: 0x%x, ref count: %d",
                Log_print2(Diags_ENTRY, "[+E] SemMP_delete> sem: 0x%x,
                ref count: %d", sem->id, semctl(sem->id, _SemMP_REFCOUNT,
                (IArg)GETVAL, (IArg)(semU)));

        /* Decrement the reference count */
        semBuf.sem_num = _SemMP_REFCOUNT;
        semBuf.sem_op = -1;
        semBuf.sem_flg = SEM_UNDO;

        if (semop(sem->id, &semBuf, 1) == -1) {
            Log_print1(Diags_USER7,
                    "[+7] Failed to decrement reference count on sem 0x%x",
                    (IArg)(sem->id));
        }

        refCount = semctl(sem->id, _SemMP_REFCOUNT, GETVAL, semU);

        if (refCount == 0) {
            /* Try to remove the semaphore */
            if (semctl(sem->id, 0, IPC_RMID, semU) == -1) {
                Log_print1(Diags_USER7,
                        "[+7] SemMP_delete> Failed to delete semaphore: 0x%x",
                        (IArg)(sem->id));
            }
            else {
                Log_print1(Diags_USER1,
                        "[+1] SemMP_delete> Deleted semaphore: 0x%x",
                        (IArg)(sem->id));
            }
        }
        else if (refCount < 0) {
            Log_print2(Diags_USER7,
                    "[+7] SemMP_delete> semctl returned ref count %d on sem "
                    "0x%x", (IArg)refCount, (IArg)(sem->id));
            Assert_isTrue(refCount >= 0, (Assert_Id)NULL);
        }

        /* Leave critical section */
        exitCS(mutexId);

        Memory_free(sem, sizeof(SemMP_Obj), NULL);
    }

    Log_print0(Diags_EXIT, "[+X] Leaving SemMP_delete>");
}

/*
 *  ======== SemMP_getCount ========
 */
Int SemMP_getCount(SemMP_Handle sem)
{
    SemUnion semU;
    Int      count;

    count = semctl(sem->id, _SemMP_SEMCOUNT, GETVAL, semU);

    return (count);
}

/*
 *  ======== SemMP_getRefCount ========
 */
Int SemMP_getRefCount(SemMP_Handle sem)
{
    SemUnion semU;
    Int      count;

    count = semctl(sem->id, _SemMP_REFCOUNT, GETVAL, semU);

    return (count);
}

/*
 *  ======== SemMP_init ========
 */
Void SemMP_init(Void)
{
    Registry_Result   result;

    /*
     *  No need to reference count for Registry_addModule(), since there
     *  is no way to remove the module.
     */
    if (regInit == 0) {
        /* Register this module for logging */
        result = Registry_addModule(&ti_sdo_ce_osal_SemMP_desc, SemMP_MODNAME);
        Assert_isTrue(result == Registry_SUCCESS, (Assert_Id)NULL);

        if (result == Registry_SUCCESS) {
            /* Set the diags mask to the CE default */
            CESettings_init();
            CESettings_setDiags(SemMP_MODNAME);
        }
        regInit = 1;
    }

    if (curInit++ == 0) {
        Global_atexit((Fxn)cleanup);
    }
}

/*
 *  ======== SemMP_pend ========
 */
Int SemMP_pend(SemMP_Handle sem, UInt32 timeout)
{
    Int    status = SemMP_EOK;
    struct sembuf semBuf;

    Log_print2(Diags_ENTRY, "[+E] Entered SemMP_pend> sem[0x%x] timeout[0x%x]",
            (IArg)sem, (IArg)timeout);

    /* Timeouts not supported yet */
    Assert_isTrue(timeout == SemMP_FOREVER, (Assert_Id)NULL);

    semBuf.sem_num = _SemMP_SEMCOUNT;
    semBuf.sem_op = -1;
    semBuf.sem_flg = SEM_UNDO;

    /* TODO: Figure out how to do timeout */
    if (semop(sem->id, &semBuf, 1) == -1) {
        status = SemMP_EFAIL;
        Log_print1(Diags_USER7, "[+7] SemMP_pend [0x%x] failed",
                (IArg)(sem->id));
        Assert_isTrue(status == SemMP_EOK, (Assert_Id)NULL);
    }

    Log_print2(Diags_EXIT, "[+X] Leaving SemMP_pend> sem[0x%x] status[%d]",
            (IArg)sem, (IArg)status);

    return (status);
}

/*
 *  ======== SemMP_post ========
 */
Void SemMP_post(SemMP_Handle sem)
{
    struct sembuf semBuf;

    Log_print1(Diags_ENTRY, "[+E] Entered SemMP_post> sem[0x%x]", (IArg)sem);

    semBuf.sem_num = _SemMP_SEMCOUNT;
    semBuf.sem_op = 1;
    semBuf.sem_flg = SEM_UNDO;

    if (semop(sem->id, &semBuf, 1) == -1) {
        /* Should never happen */
        Log_print1(Diags_USER7, "[+7] SemMP_post [0x%x] failed",
                (IArg)(sem->id));
    }

    Log_print1(Diags_EXIT, "[+X] Leaving SemMP_post> sem[0x%x]", (IArg)sem);
}

/*
 *  ======== cleanup ========
 */
static Void cleanup(Void)
{
    Assert_isTrue(curInit > 0, (Assert_Id)NULL);

    if (--curInit == 0) {
        /* Nothing to do */
    }
}

/*
 *  ======== enterCS ========
 *  Enter critical section
 *  WARNING: Calls to this function with the same key cannot be nested!
 */
static Int enterCS(Int key)
{
    Int     count = 0;
    Int     id = 0;

    Log_print1(Diags_ENTRY, "[+E] Entered enterCS> key[0x%x]", (IArg)key);

    /*
     *  Attempt to create a new semaphore with this key, for exclusive
     *  access. If this call fails, we assume it's because another process
     *  has created it. In that case we loop until we can create it.
     */
    id = semget((key_t)key, 1, 0666 | IPC_CREAT | IPC_EXCL);

    while (id == -1) {
        /* Yield */
        count++;

        if (count > MAXCOUNT) {
            Log_print1(Diags_USER6,
                    "[+6] enterCS> Timing out trying to enter critical "
                    "section, key = 0x%x", (IArg)key);
            count = 0;
        }

        usleep(1);

        /*
         *  Wait til the semaphore is removed by the other process so we
         *  can get it for ourself.
         */
        id = semget((key_t)key, 1, 0666 | IPC_CREAT | IPC_EXCL);
    }

    Log_print1(Diags_ENTRY, "[+E] Leaving enterCS> id[0x%x]", (IArg)id);

    return (id);
}

/*
 *  ======== exitCS ========
 *  Exit critical section
 */
static Void exitCS(Int id)
{
    SemUnion semU;

    Log_print1(Diags_ENTRY, "[+E] Entered exitCS> id[0x%x]", (IArg)id);

    /*
     *  Delete the semaphore  Note: the second argument (semaphore number)
     *  will be ignored in this call.
     */
    if (semctl(id, 0, IPC_RMID, semU) == -1) {
        /* Error that should never happen. */
        Log_print1(Diags_USER7,
                "[+7] exitCS> semctl(%d, 0, IPC_RMID,...) failed!", (IArg)id);
        Assert_isTrue(0 == 1, (Assert_Id)NULL);
    }

    Log_print0(Diags_EXIT, "[+X] Leaving exitCS");
}
